#!/usr/bin/env python3
import sys

if len(sys.argv) < 4:
    print("Usage: calc.py number_of_threads1 power1 number_of_threads2 power2")
    sys.exit(0)

pt=0.02

t1=int(sys.argv[1])
p1=int(sys.argv[2])
t2=int(sys.argv[3])
p2=int(sys.argv[4])
if p2 > p1:
    t=p1
    p1=p2
    p2=t
    t=t1
    t1=t2
    t2=t
found_match=False
power_ratio=p1/p2
print(f"Faster power: {p1}\tSlower power: {p2}");
print(f"Faster threads: {t1}\tSlower threads: {t2}");
for i in range(1,100):
    for j in range(1,100):
        tp1=t1*i
        tp2=t2*j*power_ratio
        if ((tp1 >= tp2) and (tp1 <= (tp2 + pt*tp2))) or ((tp2 >= tp1) and (tp2 <= (tp1 + pt*tp1))):
            print(f"Found: {tp1}\t{tp2}")
            print(f"Node: {tp1}\t{t2*j}")
            found_match=True
            break;
    if found_match:
        break;
